// fact_recurse.cpp
// Glenn G. Chappell
// 3 Dec 2013
//
// For CS 202 Fall 2013
// Factorial: Recursive & Iterative

#include <iostream>
using std::cout;
using std::endl;
using std::cin;


// fact_recursive
// Factorial, recursive version.
//
// Given n >= 0, returns n! = n*(n-1)* ... *1.
//
// Assuming type (long long) is 64-bit signed, returns correct result
// for n in [0, 20].
long long fact_recursive(int n)
{
    // BASE CASE
    if (n == 0)
        return (long long)(1);

    // RECURSIVE CASE
    return (long long)(n) * fact_recursive(n-1);
}


// fact
// Factorial, iterative version.
//
// Given n >= 0, returns n! = n*(n-1)* ... *1.
//
// Assuming type (long long) is 64-bit signed, returns correct result
// for n in [0, 20].
long long fact(int n)
{
    long long result = 1;
    for (int i = 1; i <= n; ++i)
    {
        result *= (long long)(i);
    }

    return result;
}


int main()
{
    for (int n = 0; n <= 20; ++n)
    {
        //cout << n << "! = " << fact(n) << endl;
        cout << n << "! = " << fact_recursive(n) << endl;
    }

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

